<template>
  <div class="ele-body">
    <el-card shadow="never">
      <!-- 搜索表单 -->
      <el-form label-width="77px" class="ele-form-search">
        <el-row :gutter="15">
          <el-col :md="6" :sm="12">
            <el-form-item label="客户:">
              <el-input
                placeholder="请输入手机号"
                clearable
                v-model="where.title"
              />
            </el-form-item>
          </el-col>
          <el-col v-bind="styleResponsive ? { lg: 12, md: 12 } : { span: 12 }">
            <el-form-item label="筛选日期:">
              <el-date-picker
                unlink-panels
                v-model="where.dateRange"
                range-separator="-"
                type="daterange"
                end-placeholder="结束日期"
                start-placeholder="开始日期"
                :picker-options="pickerOptions"
                value-format="yyyy-MM-dd"
                class="ele-fluid"
              />
            </el-form-item>
          </el-col>
          <el-col :md="6" :sm="12">
            <div class="ele-form-actions">
              <el-button
                type="primary"
                icon="el-icon-search"
                class="ele-btn-icon"
                @click="reload"
              >
                查询
              </el-button>
              <el-button @click="reset">重置</el-button>
            </div>
          </el-col>
        </el-row>
      </el-form>
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :columns="columns"
        :datasource="datasource"
        :selection.sync="selection"
        cache-key="receiverCustomerTables"
      >
        <!-- 表头工具栏 -->
        <template v-slot:toolbar></template>
        <template v-slot:biz="{ row }">
          {{ row.biz_poi }} <br />
          {{ row.biz_name }}
        </template>
        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-link type="primary" :underline="false" @click="goDetail(row)">
            查看
          </el-link>
        </template>
      </ele-pro-table>
    </el-card>
  </div>
</template>

<script>
  import { pageCustomer } from '@/api/receiver/customer';

  export default {
    name: 'receiverClues',
    components: {},
    data() {
      return {
        where: {
          title: '',
          selectedCar: {
            brandId: '',
            seriesId: '',
            modelId: ''
          }
        },
        // 表格列配置
        columns: [
          {
            prop: 'mobile',
            label: '客户',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'biz',
            label: '所属门店',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80,
            slot: 'biz'
          },
          {
            prop: 'status_name',
            label: '状态',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'brand_detail',
            label: '关注车型',
            align: 'center',
            minWidth: 80,
            resizable: false,
            showOverflowTooltip: true
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 200,
            align: 'center',
            resizable: false,
            slot: 'action'
          }
        ],
        // 表格选中数据
        selection: [],
        // 当前编辑数据
        current: null,
        // 是否显示编辑弹窗
        showEdit: false,
        // 日期时间选择器快捷项
        pickerOptions: {
          shortcuts: [
            {
              text: '今天',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '昨天',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24);
                end.setTime(end.getTime() - 3600 * 1000 * 24);
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '最近一周',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '最近一个月',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '最近三个月',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                picker.$emit('pick', [start, end]);
              }
            }
          ]
        }
      };
    },
    created() {},
    computed: {
      // 是否开启响应式布局
      styleResponsive() {
        return this.$store.state.theme.styleResponsive;
      }
    },
    methods: {
      /* 下拉按钮点击 */
      dropClick(command, row) {
        if (command === 'edit') {
          this.current = row;
          this.showEdit = true;
        } else if (command === 'brokerage') {
          this.current = row;
          this.showEditBrokerage = true;
        } else if (command === 'coupon') {
          const path = '/car/product/coupon';
          this.$nextTick(() => {
            this.$router.push({
              path,
              query: row ? { id: row.id, title: row.title } : undefined
            });
          });
        }
      },
      goDetail(row) {
        const path = '/receiver/customer/detail';
        this.$router.push({
          path,
          query: row ? { id: row.id, title: row.title } : undefined
        });
      },
      /* 表格数据源 */
      datasource({ page, limit, where, order }) {
        return pageCustomer({ ...where, ...order, page, limit });
      },
      /* 刷新表格 */
      reload() {
        this.$refs.table.reload({ page: 1, where: this.where });
      },
      /* 重置搜索 */
      reset() {
        this.where = {};
      }
    }
  };
</script>
<style scoped></style>
